package org.phosphoresce.socket.proxy.http.handler;


/**
 * HTTPリバースプロキシサーバー処理実行時のイベントハンドラクラスインタフェース<br>
 * 
 * @author Kitagawa<br>
 * 
 *<!--
 * 更新日		更新者			更新内容
 * 2008/10/18	Kitagawa		新規作成
 *-->
 */
public interface HttpReverseProxyHandler {

	/**
	 * イベントハンドル処理を実行します。<br>
	 * @return イベントハンドル処理後、プロキシコントローラーの後続処理を実施する場合にtrueを返却
	 * @throws Throwable 正常にイベントハンドル処理が行えなかった場合にスローされます
	 */
	public boolean execute() throws Throwable;
}