package org.phosphoresce.commons.mail.configure;

import java.util.Properties;

import org.phosphoresce.commons.mail.MailConfiguration;
import org.phosphoresce.commons.util.StringUtil;

/**
 * SMTPT[o[ݒێNXB<br>
 * 
 * @author Kitagawa<br>
 * 
 *<!--
 * XV		XV			XVe
 * 2007/02/24	Kitagawa		VK쐬
 *-->
 */
public final class MailSMTPConfiguration extends MailConfiguration {

	/** T[o[ڑvgR */
	public static final String PROTOCOL = "smtp";

	/** fBtHgT[o[|[g */
	public static final int DEFAULT_PORT = 25;

	/**
	 * RXgN^<br>
	 */
	public MailSMTPConfiguration() {
		super();
		super.setProtocol(PROTOCOL);
		super.setPort(DEFAULT_PORT);
	}

	/**
	 * RXgN^<br>
	 * @param server T[o[AhX
	 * @param port T[o[|[g
	 * @param user T[o[F؃[U[
	 * @param password T[o[F؃pX[h
	 */
	public MailSMTPConfiguration(String server, int port, String user, String password) {
		super(PROTOCOL, server, port, user, password);
	}

	/**
	 * RXgN^<br>
	 * @param server T[o[AhX
	 * @param user T[o[F؃[U[
	 * @param password T[o[F؃pX[h
	 */
	public MailSMTPConfiguration(String server, String user, String password) {
		super(PROTOCOL, server, DEFAULT_PORT, user, password);
	}

	/**
	 * ݒ񂪑Mp`ł邩擾܂B<br>
	 * @return Mp`łꍇAtrueԋp
	 * @see org.phosphoresce.commons.mail.MailConfiguration#isSender()
	 */
	protected boolean isSender() {
		return true;
	}

	/**
	 * SMTPݒIuWFNgێPropertiesIuWFNgɒǉ܂B<br>
	 * @param properties PropertiesIuWFNg
	 * @see org.phosphoresce.commons.mail.MailConfiguration#appendSessionProperties(java.util.Properties)
	 */
	protected void appendSessionProperties(Properties properties) {
		properties.put("mail.smtp.host", getServer());
		if (!StringUtil.isEmpty(getUser()) || !StringUtil.isEmpty(getPassword())) {
			properties.put("mail.smtp.auth", "true");
		}
	}
}
