package org.phosphoresce.webcore.ext.struts.action;

import org.phosphoresce.webcore.core.transaction.TransactionUser;
import org.phosphoresce.webcore.ext.struts.annotation.StrutsForm;

/**
 * ダミーフォームクラス<br>
 * <br>
 * サーブレットアクションモジュールが存在しないリクエストパス受領時のリクエストプロセッサーで返却されるダミーのフォームとなります。<br>
 * 
 * @author Kitagawa<br>
 * 
 *<!--
 * 更新日		更新者			更新内容
 * 2010/07/19	Kitagawa		新規作成
 *-->
 */
@StrutsForm
public final class DummyForm extends AbstractForm<TransactionUser> {

	/**
	 * フォームオブジェクトをリセットします。<br>
	 * @param servlet サーブレットコンテナオブジェクト
	 * @param session ウィンドウセッションオブジェクト
	 * @see org.phosphoresce.webcore.ext.struts.action.AbstractForm#reset(org.phosphoresce.webcore.ext.struts.action.ServletContainer, org.phosphoresce.webcore.ext.struts.action.WindowSessionContainer)
	 */
	@Override
	public void reset(ServletContainer<TransactionUser> servlet, WindowSessionContainer<TransactionUser> session) {
	}

	/**
	 * フォームオブジェクトを初期化します。<br>
	 * @param servlet サーブレットコンテナオブジェクト
	 * @param session ウィンドウセッションオブジェクト
	 * @see org.phosphoresce.webcore.ext.struts.action.AbstractForm#init(org.phosphoresce.webcore.ext.struts.action.ServletContainer, org.phosphoresce.webcore.ext.struts.action.WindowSessionContainer)
	 */
	@Override
	public void init(ServletContainer<TransactionUser> servlet, WindowSessionContainer<TransactionUser> session) {
	}
}
